## persistent-cache-cpp 1.0.4%2B16.04.20160117

=== tests/core/persistent_string_cache/CMakeLists.txt ===
add_executable(persistent_string_cache_test persistent_string_cache_test.cpp)
target_link_libraries(persistent_string_cache_test ${TESTLIBS})
add_definitions(-DTEST_DIR="${CMAKE_CURRENT_BINARY_DIR}")

add_test(persistent_string_cache persistent_string_cache_test)
set(TARGETS ${TARGETS} persistent_string_cache_test)

add_executable(speed_test speed_test.cpp)
target_link_libraries(speed_test ${TESTLIBS})
if (${slowtests})
    add_test(speed speed_test)
    set(TARGETS ${TARGETS} speed_test)
endif()

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} ${TARGETS} PARENT_SCOPE)

## persistent-cache-cpp 1.0.4%2B16.10.20160823

=== core/CMakeLists.txt ===
include(FindPkgConfig)
find_package(Boost COMPONENTS system filesystem)

set(TESTLIBS ${LIBNAME} boost_filesystem boost_system leveldb gtest)

add_subdirectory(persistent_cache)
add_subdirectory(persistent_string_cache)
add_subdirectory(internal)

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

## persistent-cache-cpp 1.0.4+16.04.20160117

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(persistent-cache-cpp C CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(LIBNAME persistent-cache-cpp)

set(VERSION_MAJOR 1)
set(VERSION_MINOR 0)
set(VERSION_MICRO 4)
set(LIBVERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}")

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lower case

set(ACCEPTED_BUILD_TYPES "" none release debug relwithdebinfo coverage)
list(FIND ACCEPTED_BUILD_TYPES "${cmake_build_type_lower}" IS_BUILD_TYPE_ACCEPTED)
if(${IS_BUILD_TYPE_ACCEPTED} EQUAL -1)
    message(FATAL_ERROR "Invalid CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}\nValid types are: ${ACCEPTED_BUILD_TYPES}")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -Wall -pedantic -Wextra")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wctor-dtor-privacy -Wold-style-cast")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS} ${EXTRA_CXX_WARNINGS}")

# By default, for release builds, warnings become hard errors.
if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

# If warnings are errors, don't error on deprecated declarations.
if (${Werror})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
    if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
    endif()
endif()

# Flags for thread/address sanitizer
set(SANITIZER "" CACHE STRING "Build with -fsanitize=<value> (legal values: thread, address)")

if ("${SANITIZER}" STREQUAL "")
    # Do nothing
elseif (${SANITIZER} STREQUAL "thread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer -g")
elseif (${SANITIZER} STREQUAL "address")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -g")
else()
    message(FATAL_ERROR "Invalid SANITIZER setting: ${SANITIZER}")
endif()

# Some tests are slow, so make it possible not to run them
# during day-to-day development.
option(slowtests "Run slow tests" ON)

# Definitions for testing with valgrind.

configure_file(CTestCustom.cmake.in CTestCustom.cmake) # Tests in CTestCustom.cmake are skipped for valgrind

find_program(MEMORYCHECK_COMMAND NAMES valgrind)
if (MEMORYCHECK_COMMAND)
    set(MEMORYCHECK_COMMAND_OPTIONS
        "--suppressions=${CMAKE_SOURCE_DIR}/valgrind-suppress --errors-for-leak-kinds=definite --show-leak-kinds=definite --leak-check=full --num-callers=50 --error-exitcode=3"
    )
    add_custom_target(valgrind DEPENDS NightlyMemCheck)
else()
    message(WARNING "Cannot find valgrind: valgrind target will not be available")
endif()

include(CTest)
enable_testing()

include(EnableCoverageReport)

find_package(Boost COMPONENTS filesystem REQUIRED)
find_package(Threads REQUIRED)

include_directories(include)

add_subdirectory(src)
add_subdirectory(include)
add_subdirectory(tests)
add_subdirectory(data)
add_subdirectory(examples)
add_subdirectory(doc)

enable_coverage_report(
    TARGETS
        ${LIBNAME}
        ${UNIT_TEST_TARGETS}
    FILTER
        ${CMAKE_SOURCE_DIR}/tests/*
        ${CMAKE_BINARY_DIR}/*
    TESTS
        ${UNIT_TEST_TARGETS}
)

include(UseDoxygen OPTIONAL)

file(GLOB public_headers ${CMAKE_SOURCE_DIR}/include/core/*.h)
add_doxygen(
    ${LIBNAME}-doc
    INPUT
        ${CMAKE_BINARY_DIR}/doc/main_page.dox
        ${public_headers}
    OUTPUT_DIRECTORY
        ${CMAKE_BINARY_DIR}/doc
    STRIP_FROM_PATH
        "${CMAKE_SOURCE_DIR}/src"
    STRIP_FROM_INC_PATH
        "${CMAKE_SOURCE_DIR}/include"
    EXCLUDE_PATTERNS
        */internal/*
    EXCLUDE_SYMBOLS
        *::internal*
        *::Priv
    ALL
)
install(DIRECTORY ${CMAKE_BINARY_DIR}/doc/html
        DESTINATION share/doc/${LIBNAME})

## persistent-cache-cpp 1.0.4+16.10.20160823

=== CMakeLists.txt ===
if (NOT DEFINED GTEST_ROOT)
    set(GTEST_ROOT /usr/src/gtest)
endif()

set(GTEST_SRC_DIR "${GTEST_ROOT}/src")
set(GTEST_INCLUDE_DIR ${GTEST_ROOT})

add_library(gtest STATIC
    ${GTEST_SRC_DIR}/gtest-all.cc
    ${GTEST_SRC_DIR}/gtest_main.cc
)
set_target_properties(gtest PROPERTIES INCLUDE_DIRECTORIES ${GTEST_INCLUDE_DIR})
target_link_libraries(gtest ${CMAKE_THREAD_LIBS_INIT})

# Make sure we always build gtest with debug info, otherwise we don't
# get line numbers for the code that is dragged in by the test macros.
set_property(TARGET gtest APPEND_STRING PROPERTY COMPILE_FLAGS " -g")

# gtest won't compile cleanly without this.
set_property(TARGET gtest APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-missing-field-initializers -Wno-old-style-cast")

add_subdirectory(copyright)
add_subdirectory(core)
add_subdirectory(headers)
add_subdirectory(whitespace)

# Tests in subdirectories set this. We push it up to the parent so we can
# exclude the unit tests from coverage.
set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== headers/CMakeLists.txt ===
#
# Test that all header files compile stand-alone and that no public header includes an internal one.
#

set(root_inc_dir ${CMAKE_SOURCE_DIR}/include)

set(subdirs
    core
)

foreach(dir ${subdirs})
    string(REPLACE "/" "-" location ${dir})

    set(public_inc_dir ${root_inc_dir}/${dir})
    set(internal_inc_dir ${public_inc_dir}/internal)

    if (${slowtests})
        # Test that each public header compiles stand-alone.
        add_test(stand-alone-${location}-headers
            ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
                ${public_inc_dir} ${CMAKE_CXX_COMPILER} "${CMAKE_CXX_COMPILER_ARG1} -fPIC -fsyntax-only -I${root_inc_dir} -I${public_inc_dir} ${other_inc_dirs} ${CMAKE_CXX_FLAGS} ${extra_inc_dirs}")

        # Test that each internal header compiles stand-alone.
        if (IS_DIRECTORY ${internal_inc_dir})
            add_test(stand-alone-${location}-internal-headers
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
                    ${internal_inc_dir} ${CMAKE_CXX_COMPILER} "${CMAKE_CXX_COMPILER_ARG1} -fPIC -fsyntax-only -I${root_inc_dir} -I${internal_inc_dir} ${other_inc_dirs} ${CMAKE_CXX_FLAGS} ${extra_includes}")
        endif()
    endif()

    # Test that no public header includes an internal header
    add_test(clean-public-${location}-headers ${CMAKE_CURRENT_SOURCE_DIR}/check_public_headers.py ${public_inc_dir})
endforeach()

## persistent-cache-cpp 1.0.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(persistent-cache-cpp C CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(LIBNAME persistent-cache-cpp)

set(VERSION_MAJOR 1)
set(VERSION_MINOR 0)
set(VERSION_MICRO 5)
set(LIBVERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}")

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lower case

set(ACCEPTED_BUILD_TYPES "" none release debug relwithdebinfo coverage)
list(FIND ACCEPTED_BUILD_TYPES "${cmake_build_type_lower}" IS_BUILD_TYPE_ACCEPTED)
if(${IS_BUILD_TYPE_ACCEPTED} EQUAL -1)
    message(FATAL_ERROR "Invalid CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}\nValid types are: ${ACCEPTED_BUILD_TYPES}")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -Wall -pedantic -Wextra")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wctor-dtor-privacy -Wold-style-cast")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS} ${EXTRA_CXX_WARNINGS}")

# By default, for release builds, warnings become hard errors.
if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

# If warnings are errors, don't error on deprecated declarations.
if (${Werror})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
    if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
    endif()
endif()

# Flags for thread/address sanitizer
set(SANITIZER "" CACHE STRING "Build with -fsanitize=<value> (legal values: thread, address)")

if ("${SANITIZER}" STREQUAL "")
    # Do nothing
elseif (${SANITIZER} STREQUAL "thread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer -g")
elseif (${SANITIZER} STREQUAL "address")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -g")
else()
    message(FATAL_ERROR "Invalid SANITIZER setting: ${SANITIZER}")
endif()

# Some tests are slow, so make it possible not to run them
# during day-to-day development.
option(slowtests "Run slow tests" ON)

# Definitions for testing with valgrind.

configure_file(CTestCustom.cmake.in CTestCustom.cmake) # Tests in CTestCustom.cmake are skipped for valgrind

find_program(MEMORYCHECK_COMMAND NAMES valgrind)
if (MEMORYCHECK_COMMAND)
    set(MEMORYCHECK_COMMAND_OPTIONS
        "--suppressions=${CMAKE_SOURCE_DIR}/valgrind-suppress --errors-for-leak-kinds=definite --show-leak-kinds=definite --leak-check=full --num-callers=50 --error-exitcode=3"
    )
    add_custom_target(valgrind DEPENDS NightlyMemCheck)
else()
    message(WARNING "Cannot find valgrind: valgrind target will not be available")
endif()

include(CTest)
enable_testing()

find_package(CoverageReport)
find_package(Boost COMPONENTS filesystem REQUIRED)
find_package(Threads REQUIRED)

include_directories(include)

add_subdirectory(src)
add_subdirectory(include)
add_subdirectory(tests)
add_subdirectory(data)
add_subdirectory(examples)
add_subdirectory(doc)

enable_coverage_report(
    TARGETS
        ${LIBNAME}
        ${UNIT_TEST_TARGETS}
    FILTER
        ${CMAKE_SOURCE_DIR}/tests/*
        ${CMAKE_BINARY_DIR}/*
    TESTS
        ${UNIT_TEST_TARGETS}
)

find_package(DoxygenBuilder)

file(GLOB public_headers ${CMAKE_SOURCE_DIR}/include/core/*.h)
add_doxygen(
    ${LIBNAME}-doc
    INPUT
        ${CMAKE_BINARY_DIR}/doc/main_page.dox
        ${public_headers}
    OUTPUT_DIRECTORY
        ${CMAKE_BINARY_DIR}/doc
    STRIP_FROM_PATH
        "${CMAKE_SOURCE_DIR}/src"
    STRIP_FROM_INC_PATH
        "${CMAKE_SOURCE_DIR}/include"
    EXCLUDE_PATTERNS
        */internal/*
    EXCLUDE_SYMBOLS
        *::internal*
        *::Priv
    ALL
)
install(DIRECTORY ${CMAKE_BINARY_DIR}/doc/html
        DESTINATION share/doc/${LIBNAME})

=== data/CMakeLists.txt ===
# Set up package config.
set(PKGCONFIG_NAME ${LIBNAME})
set(PKGCONFIG_DESCRIPTION "A cache of key-value pairs with persistent storage for C++")
set(VERSION "1.0")

configure_file(lib${LIBNAME}.pc.in lib${LIBNAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${LIBNAME}.pc DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE}/pkgconfig)

=== src/core/CMakeLists.txt ===
find_library(LEVELDB NAMES leveldb REQUIRED)

add_subdirectory(internal)

set(CACHE_SRC
    ${CACHE_SRC}
    ${CMAKE_CURRENT_SOURCE_DIR}/persistent_cache_stats.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/persistent_string_cache.cpp
)

add_library(${LIBNAME} STATIC ${CACHE_SRC})
target_link_libraries(${LIBNAME} ${LEVELDB})

install(TARGETS ${LIBNAME}
        DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE})

=== tests/core/internal/CMakeLists.txt ===
add_subdirectory(persistent_string_cache_impl)

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} ${TARGETS} PARENT_SCOPE)

=== debian/changelog ===
persistent-cache-cpp (1.0.5-4) unstable; urgency=medium

  * Team upload.

  [ Mike Gabriel ]
  * [4162d23] debian/: Update upstream Git repo URL.

  [ Adrian Bunk ]
  * [969fe7b] Include missing header. (Closes: #1013012)

  [ Anton Gladky ]
  * [24d38ff] Add debian/.gitlab-ci.yml.
  * [a1d7fa7] Set upstream metadata fields: Repository.
  * [414caec] Remove obsolete field Name from debian/upstream/metadata
              (already present in machine-readable debian/copyright).
  * [12adb1b] Update standards version to 4.6.1, no changes needed.
  * [0a467ff] Minor update of install files

 -- Anton Gladky <gladk@debian.org>  Wed, 05 Oct 2022 22:27:53 +0200

persistent-cache-cpp (1.0.5-3) unstable; urgency=medium

  * Source-only re-upload as is.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 25 Dec 2021 22:51:41 +0100

persistent-cache-cpp (1.0.5-2) unstable; urgency=medium

  * debian/patches/README:
    + Add file. Explain your patch naming scheme.
  * debian/patches:
    + Add 0001_explicitly-include-boost-optional-optional_io-hpp.patch.
      Explicitly include boost/optional/optional_io.hpp as required with
      current Boost.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 25 Nov 2021 12:13:52 +0100

persistent-cache-cpp (1.0.5-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #998702).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 08 Nov 2021 18:25:11 +0100

=== debian/control ===
Source: persistent-cache-cpp
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 1.5-8~),
               debhelper-compat (= 13),
               doxygen,
               googletest,
               libboost-filesystem-dev,
               libgtest-dev,
               libleveldb-dev,
               lsb-release,
               pkg-config,
               python3 <!nocheck>,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lib-cpp/persistent-cache-cpp
Vcs-Git: https://salsa.debian.org/ubports-team/persistent-cache-cpp.git
Vcs-Browser: https://salsa.debian.org/ubports-team/persistent-cache-cpp/

Package: persistent-cache-cpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libboost-dev,
         libleveldb-dev,
         pkg-config,
Description: Cache of key-value pairs with persistent storage for C++ 11
 This API provides a cache of key-value pairs with a backing store. It is
 intended for caching arbitrary (possibly large) amounts of data, such as
 might be needed by a web browser cache. The cache supports both
 least-recently-used and time-to-live expiration policies. It scales to
 large numbers (millions) of entries and is very fast. The implementation
 is based on leveldb and typically provides throughput many times larger
 than the I/O bandwidth to disk.
 .
 The cache is robust in the face of crashes and power loss. After a
 re-start, it is guaranteed to be in a consistent state with correct
 data. Some number of updates that were made just prior to a power loss
 or kernel crash can be lost; however, if just the calling process
 crashes, all updates that were made prior to the crash are guaranteed to
 be on disk.

Package: persistent-cache-cpp-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Documentation for persistent-cache-cpp-dev
 This API provides a cache of key-value pairs with a backing store. It is
 intended for caching arbitrary (possibly large) amounts of data, such as
 might be needed by a web browser cache. The cache supports both
 least-recently-used and time-to-live expiration policies. It scales to
 large numbers (millions) of entries and is very fast. The implementation
 is based on leveldb and typically provides throughput many times larger
 than the I/O bandwidth to disk.
 .
 The cache is robust in the face of crashes and power loss. After a
 re-start, it is guaranteed to be in a consistent state with correct
 data. Some number of updates that were made just prior to a power loss
 or kernel crash can be lost; however, if just the calling process
 crashes, all updates that were made prior to the crash are guaranteed to
 be on disk.
 .
 This package provides examples and the API reference.

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lib-cpp/persistent-cache-cpp/tags .*/persistent-cache-cpp-(\d\S+)\.tar\.gz

## persistent-cache-cpp 1.0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,13 +7,15 @@
 
 project(persistent-cache-cpp C CXX)
 
+option(BUILD_SHARED_LIBS "Build library as shared" OFF)
+
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
 set(LIBNAME persistent-cache-cpp)
 
 set(VERSION_MAJOR 1)
 set(VERSION_MINOR 0)
-set(VERSION_MICRO 5)
+set(VERSION_MICRO 7)
 set(LIBVERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}")
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lower case
@@ -26,7 +28,7 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -Wall -pedantic -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++14 -Wall -pedantic -Wextra")
 
 # Some additional warnings not included by the general flags set above.
 set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")

=== data/CMakeLists.txt ===
# Set up package config.
set(PKGCONFIG_NAME ${LIBNAME})
set(PKGCONFIG_DESCRIPTION "A cache of key-value pairs with persistent storage for C++")
set(VERSION "1.0.7")

set(PROPAGATED_LINK_FLAGS "")
if(NOT BUILD_SHARED_LIBS)
    set(PROPAGATED_LINK_FLAGS "${PROPAGATED_LINK_FLAGS} -lleveldb")
endif()

configure_file(lib${LIBNAME}.pc.in lib${LIBNAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${LIBNAME}.pc DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE}/pkgconfig)

=== examples/CMakeLists.txt ===
set(install_dir ${CMAKE_INSTALL_PREFIX}/share/doc/${LIBNAME}/examples)

set(examples
    string_cache
    person_cache
)

foreach(e ${examples})
    add_executable(${e} ${e}.cpp)
    target_link_libraries(${e} ${LIBNAME})
    if ("${cmake_build_type_lower}" STREQUAL "coverage")
        SET_PROPERTY(TARGET ${e} APPEND_STRING PROPERTY LINK_FLAGS " -g --coverage")
    endif()
    install(FILES ${e}.cpp
            DESTINATION ${install_dir})
    add_test(${e}_test ${e})
endforeach()

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/persistent_string_cache.cpp
 )
 
-add_library(${LIBNAME} STATIC ${CACHE_SRC})
+add_library(${LIBNAME} ${CACHE_SRC})
 target_link_libraries(${LIBNAME} ${LEVELDB})
 
 install(TARGETS ${LIBNAME}

=== debian/changelog ===
persistent-cache-cpp (1.0.7-2) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/patches:
    + Add 1001_fix-setfill-not-defined-in-scope.patch. Fix FTBFS against GCC-14.
      (Closes: #1077427).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 14 Aug 2024 19:14:12 +0200

persistent-cache-cpp (1.0.7-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop all patches. All applied upstream.
  * debian/copyright:
    + Update copyright attribution for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 01 Feb 2024 15:12:14 +0100

persistent-cache-cpp (1.0.5-5) unstable; urgency=medium

  [ Anton Gladky ]
  * Remove comit-hashes from changelog

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Remove unnecessary get-orig-source-target.
  * Update standards version to 4.6.2, no changes needed.

  [ Mike Gabriel ]
  * Revert "Remove unnecessary get-orig-source-target."

  [ Marius Gripsgard ]
  * debian/patches: Add patch to fix FTBFS with googletest 1.13.0
    (closes: #1041132)
  * debian/control: Add myself as uploader

 -- Marius Gripsgard <mariogrip@debian.org>  Wed, 26 Jul 2023 20:29:23 +0200

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
+ Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: cmake,
                cmake-extras (>= 1.5-8~),
                debhelper-compat (= 13),
@@ -15,7 +16,7 @@
                lsb-release,
                pkg-config,
                python3 <!nocheck>,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lib-cpp/persistent-cache-cpp
 Vcs-Git: https://salsa.debian.org/ubports-team/persistent-cache-cpp.git

## persistent-cache-cpp 1.0.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,17 @@
-cmake_minimum_required(VERSION 2.8.11)
+cmake_minimum_required(VERSION 3.0)
 
 # Default install location. Must be set here, before setting the project.
 if (NOT DEFINED CMAKE_INSTALL_PREFIX)
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(persistent-cache-cpp C CXX)
+project(persistent-cache-cpp VERSION 1.0.8 LANGUAGES C CXX)
 
 option(BUILD_SHARED_LIBS "Build library as shared" OFF)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
 set(LIBNAME persistent-cache-cpp)
-
-set(VERSION_MAJOR 1)
-set(VERSION_MINOR 0)
-set(VERSION_MICRO 7)
-set(LIBVERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}")
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lower case
 
@@ -28,7 +23,7 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++14 -Wall -pedantic -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++17 -Wall -pedantic -Wextra")
 
 # Some additional warnings not included by the general flags set above.
 set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
@@ -82,7 +77,6 @@
 endif()
 
 include(CTest)
-enable_testing()
 
 find_package(CoverageReport)
 find_package(Boost COMPONENTS filesystem REQUIRED)
@@ -92,7 +86,9 @@
 
 add_subdirectory(src)
 add_subdirectory(include)
-add_subdirectory(tests)
+if(BUILD_TESTING)
+    add_subdirectory(tests)
+endif()
 add_subdirectory(data)
 add_subdirectory(examples)
 add_subdirectory(doc)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Set up package config.
 set(PKGCONFIG_NAME ${LIBNAME})
 set(PKGCONFIG_DESCRIPTION "A cache of key-value pairs with persistent storage for C++")
-set(VERSION "1.0.7")
+set(VERSION "1.0.8")
 
 set(PROPAGATED_LINK_FLAGS "")
 if(NOT BUILD_SHARED_LIBS)

=== debian/changelog ===
persistent-cache-cpp (1.0.8-1) unstable; urgency=medium

  * New upstream release.
    - Support building against GTest/GMock >= 1.17.0. (Closes: #1114258).
  * debian/patches:
    + Drop 1001_fix-setfill-not-defined-in-scope.patch. Applied upstream.
    + Add 1001_CMakeLists.txt-Bump-cmake_minimum_required-to-versio.patch.
      Support building with CMake 4. (Closes: #1113398).
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
    + In B-D, switch from pkg-config to pkgconf. Thanks, lintian.
    + In D (persistent-cache-cpp-dev), switch from pkg-config to pkgconf.
      Thanks, lintian.
  * debian/copyright:
    + Update copyright attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 06 Sep 2025 11:16:47 +0200

## persistent-cache-cpp 1.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.10)
 
 # Default install location. Must be set here, before setting the project.
 if (NOT DEFINED CMAKE_INSTALL_PREFIX)
     set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
 endif()
 
-project(persistent-cache-cpp VERSION 1.0.8 LANGUAGES C CXX)
+project(persistent-cache-cpp VERSION 1.0.9 LANGUAGES C CXX)
 
 option(BUILD_SHARED_LIBS "Build library as shared" OFF)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Set up package config.
 set(PKGCONFIG_NAME ${LIBNAME})
 set(PKGCONFIG_DESCRIPTION "A cache of key-value pairs with persistent storage for C++")
-set(VERSION "1.0.8")
+set(VERSION "1.0.9")
 
 set(PROPAGATED_LINK_FLAGS "")
 if(NOT BUILD_SHARED_LIBS)

=== doc/CMakeLists.txt ===
configure_file(main_page.dox.in main_page.dox @ONLY)

=== include/CMakeLists.txt ===
add_subdirectory(core)

=== tests/CMakeLists.txt ===
add_subdirectory(copyright)
add_subdirectory(core)
add_subdirectory(headers)
add_subdirectory(whitespace)

# Tests in subdirectories set this. We push it up to the parent so we can
# exclude the unit tests from coverage.
set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== include/core/CMakeLists.txt ===
file(GLOB hdrs *.h)
install(FILES ${hdrs} DESTINATION include/core)

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -11,5 +11,13 @@
 add_library(${LIBNAME} ${CACHE_SRC})
 target_link_libraries(${LIBNAME} ${LEVELDB})
 
+set_target_properties(
+    ${LIBNAME}
+
+    PROPERTIES
+    VERSION "${PROJECT_VERSION}"
+    SOVERSION "${PROJECT_VERSION_MAJOR}"
+)
+
 install(TARGETS ${LIBNAME}
         DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE})

=== tests/core/CMakeLists.txt ===
include(FindPkgConfig)
find_package(GMock)
find_package(Boost COMPONENTS system filesystem)

set(TESTLIBS ${LIBNAME} boost_filesystem boost_system leveldb ${GMOCK_LIBRARIES})

add_subdirectory(persistent_cache)
add_subdirectory(persistent_string_cache)
add_subdirectory(internal)

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== src/core/internal/CMakeLists.txt ===
set(CACHE_INTERNAL_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/persistent_string_cache_impl.cpp
)

set(CACHE_SRC ${CACHE_SRC} ${CACHE_INTERNAL_SRC} PARENT_SCOPE)

=== tests/core/persistent_cache/CMakeLists.txt ===
add_executable(persistent_cache_test persistent_cache_test.cpp)
target_link_libraries(persistent_cache_test ${TESTLIBS})
add_definitions(-DTEST_DIR="${CMAKE_CURRENT_BINARY_DIR}")

add_test(persistent_cache persistent_cache_test)
set(TARGETS ${TARGETS} persistent_cache_test)

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} ${TARGETS} PARENT_SCOPE)

=== tests/core/internal/persistent_string_cache_impl/CMakeLists.txt ===
add_executable(persistent_string_cache_impl_test persistent_string_cache_impl_test.cpp)
target_link_libraries(persistent_string_cache_impl_test ${TESTLIBS})
add_definitions(-DTEST_DIR="${CMAKE_CURRENT_BINARY_DIR}")

add_test(persistent_string_cache_impl persistent_string_cache_impl_test)
set(TARGETS ${TARGETS} persistent_string_cache_impl_test)

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} ${TARGETS} PARENT_SCOPE)

=== debian/changelog ===
persistent-cache-cpp (1.0.9-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1001_CMakeLists.txt-Bump-cmake_minimum_required-to-versio.patch.
      Applied upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 07 Sep 2025 00:13:11 +0200

=== debian/control ===
--- 
+++ 
@@ -14,9 +14,9 @@
                libgtest-dev,
                libleveldb-dev,
                lsb-release,
-               pkg-config,
+               pkgconf,
                python3 <!nocheck>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lib-cpp/persistent-cache-cpp
 Vcs-Git: https://salsa.debian.org/ubports-team/persistent-cache-cpp.git
@@ -29,7 +29,7 @@
 Depends: ${misc:Depends},
          libboost-dev,
          libleveldb-dev,
-         pkg-config,
+         pkgconf,
 Description: Cache of key-value pairs with persistent storage for C++ 11
  This API provides a cache of key-value pairs with a backing store. It is
  intended for caching arbitrary (possibly large) amounts of data, such as

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..
